
;This program was made by students from Department of Astronomy, Faculty of Mathematics,
;University of Belgrade, Serbia during summer practice (9.7.2007.-3.8.2007.) at Department
;of Solar Physics, Astronomical Institute, Academy of Science of the Czech Republic.



;SHORT MANUAL
;After compiling and running ev.pro you have to select apropriate number of pictures  depending on .
;spectral line
;The results of the program - coeficients of linear fitting can be seen in file "coef.txt"
;and plots are in plot[line].ps which is created in the program.

;AUTHOR
;For all sugestions and complains please contact me:
;Sonja Vidojevic, sonja@matf.bf.ac.yu


PRO evd3, FILE=file

CLOSE, /ALL

;experimental exposure time in miliseconds
;you must pick only 15 images!!!! (because there are only 15 different  exposure times)
ExT=[1,2,3,4,5,6,7,8,9,10,15,20,25,30,35, 40, 45, 50, 55, 60, 65]
nimages=n_elements(ExT)

;pick images
filenames = dialog_pickfile(/multiple_files, filter = '*.fts', $
                            title = 'd3 (you must pick exactly 21 images)')
;how many images?
;nimages = n_elements(filenames)
;Print, 'nimages = ',nimages
rsve= FLTARR(4,nimages)

result=FLTARR(4)



;witch spectral line?
imesj = STRPOS( filenames[0], '\sj\'  )
imeca = STRPOS( filenames[0], '\ca\'  )
imed3 = STRPOS( filenames[0], '\d3\'  )
imeha = STRPOS( filenames[0], '\ha\'  )
imehb = STRPOS( filenames[0], '\hb\'  )


imedat='  '

IF (imesj NE -1) then begin
imedat='sj'
imedatf='sj'
endif

IF (imeca NE -1) then begin
imedat='Ca'
imedatf='ca'
endif

IF (imed3 NE -1) then begin
imedat='D3'
imedatf='d3'
endif

IF (imeha NE -1) then begin
imedat=textoidl('H_{\alpha}')
imedatf='ha'
endif

IF (imehb NE -1) then begin
imedat=textoidl('H_{\beta}')
imedatf='hb'
endif


FOR i=0,nimages-1 DO BEGIN
;print, 'i = ', i

unit=i+1
OPENR,unit, filenames[i],/GET_LUN, ERROR = err

; If err is nonzero, something happened. Print the error message to
; the standard error file (logical unit -2):
IF (err NE 0) then PRINTF, -2, ' !ERROR_STATE.MSG = ', !ERROR_STATE.MSG


a = readfits(filenames[i],header)

result = MOMENT(a)

;PRINT, 'Mean: ', result[0] & PRINT, 'Variance: ', result[1] & $
; PRINT, 'Skewness: ', result[2] & PRINT, 'Kurtosis: ', result[3]


rsve[*,i]=result[*] ;ovaj red radi isto sto i sledeci redovi

;rsve[0,i]=result[0]
;rsve[1,i]=result[1]
;rsve[2,i]=result[2]
;rsve[3,i]=result[3]

ENDFOR



; Compute the first degree polynomial fit to the data:
result_fit = LINFIT(ExT, rsve[0,*] , MEASURE_ERRORS=measure_errors, $
   SIGMA=sigma)


set_plot,'ps'
imeplot=STRING(imedatf, FORMAT='(%"C:\\Documents and Settings\\drugi\\My Documents\\PRAG2007\\roman\\plot%s.ps")')
device,filename=imeplot;, /color;, /ENCAPSULATED
; Print the coefficients:
PRINT, 'Coefficients (y=a+bx): ', result_fit

PRINT, 'Standard errors: ', sigma

y=FLTARR(n_elements(ExT))

FOR i=0, n_elements(ExT)-1 DO BEGIN
y[i]=result_fit[0] + result_fit[1]*ExT[i]
ENDFOR


y1 = REPLICATE( 4096, n_elements(ExT) )
tekst=STRING(imedat, result_fit[0], sigma[0], result_fit[1], sigma[1],$
	FORMAT='(%"%s, y = a + bx,(a =%10.2f \xb1%10.2f,  b = %10.2f \xb1%10.2f)")')
tekst=STRCOMPRESS(tekst)


tekstf=STRING(imedatf, result_fit[0], sigma[0], result_fit[1], sigma[1],$
	FORMAT='(%"%s, y = a + bx,(a =%10.2f \xb1%10.2f,  b = %10.2f \xb1%10.2f)")')
tekstf=STRCOMPRESS(tekstf)

print, 'tekst = ',tekst


CLOSE, /ALL


OPENU, uunit, 'C:\Documents and Settings\drugi\My Documents\PRAG2007\roman\coef.txt',/APPEND, /GET_LUN, ERROR = err

; If err is nonzero, something happened. Print the error message to
; the standard error file (logical unit -2):
IF (err NE 0) then PRINTF, -2, ' !ERROR_STATE.MSG = ', !ERROR_STATE.MSG


printf, uunit, tekstf


;plot axis and axis titles
PLOT, ExT, rsve[0,*], XRANGE=[0,110], YRANGE=[0,5000],$
	  TITLE=tekst, $
	 ;SUBTITLE='EXPERIMENTAL DATA',
	  XTITLE='Exposure time [ms]', YTITLE='Average intensity [ADU]',$
	  /NODATA


;experimental data
OPLOT, ExT, rsve[0,*], SymSize=1, PSym=1
PSYM=1;,color=get_color('red')

;linear fit
OPLOT, ExT, y;, color=get_color('yellow')


; horizontal line (max intensity 4096 ADU)
OPLOT, ExT, y1,LINESTYLE=2;, color=get_color('blue')


device,/close

SET_PLOT, 'WIN' ;ploting to screen
;plot axis and axis titles
PLOT, ExT, rsve[0,*], XRANGE=[0,110], YRANGE=[0,5000],$
	  TITLE=tekst, $
	 ;SUBTITLE='EXPERIMENTAL DATA',
	  XTITLE='Exposure time [ms]', YTITLE='Average intensity [ADU]',$
	  /NODATA


;experimental data
OPLOT, ExT, rsve[0,*], SymSize=1,$
PSYM=1,color=get_color('yellow')

;linear fit
OPLOT, ExT, y, color=get_color('red')


; horizontal line (max intensity 4096 ADU)
OPLOT, ExT, y1,LINESTYLE=2, color=get_color('red')




END